cookutils annotate cook @ rev 147

cook: small fix in usage
author Christophe Lincoln <pankso@slitaz.org>
date Wed May 11 22:52:10 2011 +0200 (2011-05-11)
parents d9c589758654
children e7bf90b7d179
rev   line source
pankso@1 1 #!/bin/sh
pankso@1 2 #
pankso@1 3 # Cook - A tool to cook and generate SliTaz packages. Read the README
pankso@1 4 # before adding or modifing any code in cook!
pankso@1 5 #
pankso@1 6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
pankso@1 7 # Author: Christophe Lincoln <pankso@slitaz.org>
pankso@1 8 #
pankso@1 9
pankso@1 10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
pankso@1 11 [ -f "cook.conf" ] && . ./cook.conf
pankso@1 12
pankso@16 13 # Share DB and status with the Cooker.
pankso@9 14 activity="$CACHE/activity"
pankso@16 15 command="$CACHE/command"
pankso@11 16 broken="$CACHE/broken"
pankso@47 17 blocked="$CACHE/blocked"
pankso@9 18
pankso@1 19 #
pankso@1 20 # Functions
pankso@1 21 #
pankso@1 22
pankso@1 23 usage() {
pankso@1 24 cat << EOT
pankso@1 25
pankso@147 26 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command] [list|--option]
pankso@1 27
pankso@1 28 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
pankso@1 29 usage|help $(gettext "Display this short usage.")
pankso@1 30 setup $(gettext "Setup your build environment.")
pankso@9 31 test $(gettext "Test environment and cook a package.")
pankso@69 32 list-wok $(gettext "List packages in the wok.")
pankso@69 33 search $(gettext "Simple packages search function.")
paul@62 34 new $(gettext "Create a new package with a receipt".)
pankso@1 35 list $(gettext "Cook a list of packages.")
pankso@1 36 clean-wok $(gettext "Clean-up all packages files.")
paul@62 37 clean-src $(gettext "Clean-up all packages sources.")
pankso@1 38 pkglist $(gettext "Create all packages.* lists.")
pankso@1 39
pankso@1 40 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
pankso@10 41 --clean|-c Cook : $(gettext "clean the package in the wok.")
pankso@39 42 --install|-i Cook : $(gettext "cook and install the package.")
pankso@39 43 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
pankso@49 44 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
pankso@49 45 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
pankso@10 46 --wok|-w Setup: $(gettext "create also a wok from Hg repo.")
pankso@1 47
pankso@1 48 EOT
pankso@1 49 exit 0
pankso@1 50 }
pankso@1 51
paul@62 52 # Be sure we're root.
pankso@1 53 check_root() {
pankso@1 54 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
pankso@1 55 }
pankso@1 56
pankso@1 57 separator() {
pankso@1 58 echo "================================================================================"
pankso@1 59 }
pankso@1 60
pankso@1 61 status() {
pankso@1 62 echo -en "\\033[70G[ "
pankso@1 63 if [ $? = 0 ]; then
pankso@1 64 echo -en "\\033[1;32mOK"
pankso@1 65 else
pankso@1 66 echo -en "\\033[1;31mFailed"
pankso@1 67 fi
pankso@1 68 echo -e "\\033[0;39m ]"
pankso@1 69 }
pankso@1 70
pankso@13 71 # Log activities, we want first letter capitalized.
pankso@9 72 log() {
pankso@27 73 grep ^[A-Z] | \
pankso@9 74 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
pankso@9 75 }
pankso@9 76
paul@62 77 # We don't want these escapes in web interface.
pankso@1 78 clean_log() {
pankso@1 79 sed -i -e s'|\[70G\[ \[1;32m| |' \
pankso@1 80 -e s'|\[0;39m \]||' $LOGS/$pkg.log
pankso@1 81 }
pankso@1 82
pankso@23 83 # Log broken packages.
pankso@23 84 broken() {
pankso@74 85 if ! grep -q "^$pkg$" $broken; then
pankso@74 86 echo "$pkg" >> $broken
pankso@74 87 fi
pankso@23 88 }
pankso@23 89
paul@62 90 # Be sure package exists in wok.
pankso@1 91 check_pkg_in_wok() {
pankso@1 92 if [ ! -d "$WOK/$pkg" ]; then
pankso@1 93 gettext -e "\nUnable to find package in the wok:"
pankso@1 94 echo -e " $pkg\n" && exit 1
pankso@1 95 fi
pankso@1 96 }
pankso@1 97
pankso@9 98 if_empty_value() {
pankso@9 99 if [ -z "$value" ]; then
pankso@9 100 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
pankso@9 101 exit 1
pankso@9 102 fi
pankso@9 103 }
pankso@9 104
paul@62 105 # Initialize files used in $CACHE
pankso@52 106 init_db_files() {
pankso@52 107 gettext "Creating directories structure in:"; echo " $SLITAZ"
pankso@52 108 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
pankso@52 109 gettext "Creating DB files in:"; echo " $CACHE"
pankso@52 110 for f in $activity $command $broken $blocked
pankso@52 111 do
pankso@52 112 touch $f
pankso@52 113 done
pankso@52 114 }
pankso@52 115
paul@62 116 # QA: check a receipt consistency before building.
pankso@9 117 receipt_quality() {
pankso@9 118 gettext -e "QA: checking package receipt...\n"
pankso@9 119 unset online
pankso@9 120 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
pankso@9 121 online="online"
pankso@9 122 fi
pankso@9 123 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
pankso@9 124 do
pankso@9 125 unset value
pankso@44 126 value=$(grep ^$var= $receipt | cut -d \" -f 2)
pankso@9 127 case "$var" in
pankso@9 128 PACKAGE|VERSION|SHORT_DESC)
pankso@9 129 if_empty_value ;;
pankso@9 130 CATEGORY)
pankso@9 131 [ -z "$value" ] && value="empty"
pankso@9 132 valid="base-system x-window utilities network graphics \
pankso@9 133 multimedia office development system-tools security games \
pankso@9 134 misc meta non-free"
pankso@9 135 if ! echo "$valid" | grep -q -w "$value"; then
paul@62 136 gettext "QA: unknown category:"; echo -e " $value\n"
pankso@9 137 exit 1
pankso@9 138 fi ;;
pankso@9 139 WEB_SITE)
paul@62 140 # We don't check WGET_URL since if dl is needed it will fail.
paul@62 141 # Break also if we're not online. Here error is not fatal.
pankso@9 142 if_empty_value
pankso@9 143 [ -z "$online" ] || break
pankso@9 144 if ! busybox wget -s $value 2>/dev/null; then
pankso@61 145 gettext "QA: Unable to reach:"; echo -e " $value"
pankso@9 146 fi ;;
pankso@9 147 esac
pankso@9 148 done
pankso@9 149 }
pankso@9 150
pankso@9 151 # Executed before sourcing a receipt.
pankso@9 152 unset_receipt() {
pankso@9 153 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
pankso@9 154 }
pankso@9 155
paul@62 156 # Paths used in receipt and by cook itself.
pankso@1 157 set_paths() {
pankso@1 158 pkgdir=$WOK/$PACKAGE
pankso@1 159 src=$pkgdir/source/$PACKAGE-$VERSION
pankso@44 160 taz=$pkgdir/taz
pankso@44 161 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
pankso@1 162 fs=$pack/fs
pankso@1 163 stuff=$pkgdir/stuff
pankso@1 164 install=$pkgdir/install
pankso@1 165 if [ "$WANTED" ]; then
pankso@1 166 src=$WOK/$WANTED/source/$WANTED-$VERSION
pankso@1 167 install=$WOK/$WANTED/install
pankso@121 168 wanted_stuff=$WOK/$WANTED/stuff
pankso@1 169 fi
pankso@9 170 # Old way compatibility.
pankso@1 171 _pkg=$install
pankso@1 172 }
pankso@1 173
pankso@144 174 # Create source tarball when URL is a SCM.
pankso@144 175 create_tarball() {
pankso@144 176 gettext "Creating tarball: "; echo "$tarball"
pankso@144 177 tar cjf $tarball $pkgsrc || exit 1
pankso@144 178 mv $tarball $SRC && rm -rf $pkgsrc
pankso@144 179 }
pankso@144 180
pankso@145 181 # Get package source. For SCM we are in cache so clone here and create a
pankso@145 182 # tarball here.
pankso@1 183 get_source() {
pankso@115 184 pwd=$(pwd)
pankso@144 185 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
pankso@144 186 tarball=$pkgsrc.tar.bz2
pankso@9 187 case "$WGET_URL" in
pankso@145 188 http://*|ftp://*)
pankso@9 189 # Busybox Wget is better!
pankso@145 190 busybox wget -c -P $SRC $WGET_URL || \
pankso@145 191 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@145 192 https://*)
pankso@145 193 wget -c --no-check-certificate -P $SRC $WGET_URL || \
pankso@15 194 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@9 195 hg*|mercurial*)
pankso@29 196 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
pankso@9 197 url=${WGET_URL#hg|}
pankso@9 198 else
pankso@9 199 url=${WGET_URL#mercurial|}
pankso@9 200 fi
pankso@61 201 gettext -e "Getting source from Hg...\n"
pankso@61 202 echo "URL: $url"
pankso@9 203 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
pankso@15 204 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
pankso@144 205 create_tarball ;;
pankso@9 206 git*)
pankso@61 207 url=${WGET_URL#git|}
pankso@61 208 gettext -e "Getting source from Git...\n"
pankso@61 209 echo "URL: $url"
pankso@64 210 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
pankso@63 211 if [ "$BRANCH" ]; then
pankso@146 212 echo "Git branch: $BRANCH"
pankso@64 213 cd $pkgsrc && git checkout $BRANCH && cd ..
pankso@63 214 fi
pankso@144 215 create_tarball ;;
pankso@144 216 cvs*)
pankso@144 217 url=${WGET_URL#cvs|}
pankso@144 218 mod=$PACKAGE
pankso@144 219 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
pankso@144 220 gettext -e "Getting source from CVS...\n"
pankso@144 221 echo "URL: $url"
pankso@146 222 [ "$CVS_MODULE" ] && echo "CVS module: $mod"
pankso@144 223 gettext "Cloning to: "; echo "$pwd/$mod"
pankso@144 224 cvs -d:$url co $mod && mv $mod $pkgsrc
pankso@144 225 create_tarball ;;
pankso@69 226 svn*|subversion*)
pankso@146 227 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
pankso@146 228 url=${WGET_URL#svn|}
pankso@146 229 else
pankso@146 230 url=${WGET_URL#subversion|}
pankso@146 231 fi
pankso@146 232 gettext -e "Getting source from SVN...\n"
pankso@146 233 echo "URL: $url"
pankso@146 234 svn co $url $pkgsrc
pankso@146 235 create_tarball ;;
pankso@9 236 *)
pankso@9 237 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
pankso@9 238 tee -a $LOGS/$PACKAGE.log
pankso@9 239 exit 1 ;;
pankso@9 240 esac
pankso@1 241 }
pankso@1 242
pankso@9 243 # Extract source package.
pankso@1 244 extract_source() {
pankso@1 245 gettext "Extracting:"; echo " $TARBALL"
pankso@1 246 case "$TARBALL" in
pankso@120 247 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
pankso@120 248 *.tar.bz2|*.tbz) tar xjf $SRC/$TARBALL 2>/dev/null ;;
pankso@1 249 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
pankso@42 250 *.tar) tar xf $SRC/$TARBALL ;;
pankso@42 251 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
pankso@42 252 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
pankso@42 253 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
pankso@42 254 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
pankso@1 255 esac
pankso@1 256 }
pankso@1 257
pankso@9 258 # Display cooked package summary.
pankso@1 259 summary() {
pankso@1 260 cd $WOK/$pkg
pankso@1 261 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
pankso@1 262 fs=$(du -sh taz/* | awk '{print $1}')
pankso@44 263 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
pankso@44 264 files=$(cat taz/$pkg-*/files.list | wc -l)
pankso@18 265 cookdate=$(date "+%Y-%m-%d %H:%M")
pankso@101 266 sec=$time
pankso@104 267 div=$(($time / 60))
pankso@112 268 [ "$div" != 0 ] && min="~ ${div}m"
pankso@1 269 gettext "Summary for:"; echo " $PACKAGE $VERSION"
pankso@1 270 separator
pankso@67 271 [ "$prod" ] && echo "Produced : $prod"
pankso@1 272 cat << EOT
pankso@1 273 Packed : $fs
pankso@1 274 Compressed : $size
pankso@18 275 Files : $files
pankso@102 276 Cook time : ${sec}s $min
pankso@18 277 Cook date : $cookdate
pankso@1 278 $(separator)
pankso@1 279 EOT
pankso@1 280 }
pankso@1 281
paul@62 282 # Display debugging error info.
pankso@15 283 debug_info() {
pankso@17 284 echo -e "\nDebug information"
pankso@15 285 separator
pankso@48 286 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
pankso@76 287 for error in \
pankso@77 288 ERROR "No package" "cp: can't" "can't open" "can't cd" \
pankso@76 289 "error:" "fatal error:"
pankso@34 290 do
pankso@34 291 fgrep "$error" $LOGS/$pkg.log
pankso@34 292 done
pankso@15 293 separator && echo ""
pankso@15 294 }
pankso@15 295
pankso@1 296 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
pankso@1 297 # so some packages need to copy these files with the receipt and genpkg_rules.
pankso@1 298 copy_generic_files()
pankso@1 299 {
pankso@1 300 # $LOCALE is set in cook.conf
pankso@1 301 if [ "$LOCALE" ]; then
pankso@1 302 if [ -d "$_pkg/usr/share/locale" ]; then
pankso@1 303 mkdir -p $fs/usr/share/locale
pankso@1 304 for i in $LOCALE
pankso@1 305 do
pankso@1 306 if [ -d "$_pkg/usr/share/locale/$i" ]; then
pankso@1 307 cp -a $_pkg/usr/share/locale/$i $fs/usr/share/locale
pankso@1 308 fi
pankso@1 309 done
pankso@1 310 fi
pankso@1 311 fi
pankso@1 312
pankso@1 313 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
pankso@1 314 if [ "$GENERIC_PIXMAPS" != "no" ]; then
pankso@1 315 if [ -d "$_pkg/usr/share/pixmaps" ]; then
pankso@1 316 mkdir -p $fs/usr/share/pixmaps
pankso@1 317 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.png \
pankso@1 318 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 319 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.xpm \
pankso@1 320 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 321 fi
pankso@1 322
pankso@1 323 # Custom or homemade PNG pixmap can be in stuff.
pankso@1 324 if [ -f "$stuff/$PACKAGE.png" ]; then
pankso@1 325 mkdir -p $fs/usr/share/pixmaps
pankso@1 326 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
pankso@1 327 fi
pankso@1 328 fi
pankso@1 329
pankso@1 330 # Desktop entry (.desktop).
pankso@1 331 if [ -d "$_pkg/usr/share/applications" ]; then
pankso@1 332 cp -a $_pkg/usr/share/applications $fs/usr/share
pankso@1 333 fi
pankso@1 334
pankso@1 335 # Homemade desktop file(s) can be in stuff.
pankso@1 336 if [ -d "$stuff/applications" ]; then
pankso@1 337 mkdir -p $fs/usr/share
pankso@1 338 cp -a $stuff/applications $fs/usr/share
pankso@1 339 fi
pankso@1 340 if [ -f "$stuff/$PACKAGE.desktop" ]; then
pankso@1 341 mkdir -p $fs/usr/share/applications
pankso@1 342 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
pankso@1 343 fi
pankso@1 344 }
pankso@1 345
pankso@67 346 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
pankso@68 347 # as removing uneeded files like in Python packages.
pankso@1 348 strip_package()
pankso@1 349 {
pankso@67 350 gettext "Executing strip on all files..."
pankso@1 351 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
pankso@1 352 do
pankso@1 353 if [ -d "$dir" ]; then
pankso@1 354 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
pankso@1 355 fi
pankso@1 356 done
pankso@1 357 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
pankso@1 358 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
pankso@1 359 status
pankso@67 360
pankso@117 361 # Remove Python .pyc and .pyo from packages.
pankso@117 362 if echo "$DEPENDS" | fgrep -q "python"; then
pankso@68 363 gettext "Removing Python compiled files..."
pankso@67 364 find $fs -type f -name "*.pyc" -delete 2>/dev/null
pankso@67 365 find $fs -type f -name "*.pyo" -delete 2>/dev/null
pankso@117 366 status
pankso@117 367 fi
pankso@117 368
pankso@117 369 # Remove Perl perllocal.pod and .packlist from packages.
pankso@117 370 if echo "$DEPENDS" | fgrep -q "perl"; then
pankso@117 371 gettext "Removing Perl compiled files..."
pankso@67 372 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
pankso@67 373 find $fs -type f -name ".packlist" -delete 2>/dev/null
pankso@67 374 status
pankso@67 375 fi
pankso@1 376 }
pankso@1 377
pankso@8 378 # Remove installed deps.
pankso@8 379 remove_deps() {
pankso@8 380 # Now remove installed build deps.
pankso@113 381 diff="$CACHE/installed.cook.diff"
pankso@113 382 if [ -s "$CACHE/installed.cook.diff" ]; then
pankso@113 383 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
pankso@113 384 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@8 385 gettext "Build dependencies to remove:"; echo " $nb"
pankso@8 386 gettext "Removing:"
pankso@8 387 for dep in $deps
pankso@8 388 do
pankso@8 389 echo -n " $dep"
pankso@8 390 yes | tazpkg remove $dep >/dev/null
pankso@8 391 done
pankso@16 392 echo -e "\n"
pankso@113 393 # Keep the last diff for debug and info.
pankso@113 394 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
pankso@1 395 fi
pankso@1 396 }
pankso@1 397
pankso@1 398 # The main cook function.
pankso@1 399 cookit() {
pankso@11 400 echo "Cook: $PACKAGE $VERSION"
pankso@9 401 separator
pankso@1 402 set_paths
pankso@9 403 [ "$QA" ] && receipt_quality
pankso@44 404 cd $pkgdir
pankso@33 405 rm -rf install taz source
pankso@1 406
pankso@1 407 # Disable -pipe if less than 512Mb free RAM.
pankso@1 408 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
pankso@1 409 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
pankso@1 410 gettext -e "Disabling -pipe compile flag: $free RAM\n"
pankso@1 411 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
pankso@47 412 CXXFLAGS="${CXXFLAGS/-pipe}" && \
pankso@47 413 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
pankso@1 414 fi
pankso@1 415 unset free
pankso@1 416
pankso@1 417 # Export flags and path to be used by make
pankso@44 418 DESTDIR=$pkgdir/install
pankso@1 419 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS BUILD_HOST CONFIG_SITE
pankso@1 420 local LC_ALL=POSIX LANG=POSIX
pankso@1 421
pankso@126 422 # Check for build deps and handle implicit depends of *-dev packages
pankso@126 423 # (ex: libusb-dev :: libusb).
pankso@1 424 cd $INSTALLED && ls -1 > $CACHE/installed.list
pankso@1 425 [ "$DEPENDS" ] && gettext -e "Checking build dependencies...\n"
pankso@1 426 for dep in $BUILD_DEPENDS
pankso@1 427 do
pankso@126 428 implicit=${dep%-dev}
pankso@131 429 for i in $dep $implicit
pankso@126 430 do
pankso@131 431 if [ ! -f "$INSTALLED/$i/receipt" ]; then
pankso@126 432 # Try local package first.
pankso@131 433 vers=$(grep ^VERSION $WOK/$i/receipt | cut -d '"' -f 2)
pankso@131 434 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
pankso@131 435 gettext "Installing dep (pkg/local):"; echo " $i"
pankso@131 436 cd $PKGS && tazpkg install $i-$vers.tazpkg >/dev/null
pankso@126 437 else
pankso@131 438 gettext "Installing dep (web/cache):"; echo " $i"
pankso@131 439 tazpkg get-install $i >/dev/null
pankso@126 440 fi
pankso@1 441 fi
pankso@126 442 done
pankso@1 443 done
pankso@128 444 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
pankso@8 445
paul@62 446 # If a cook failed deps are not removed since we exit 1.
pankso@113 447 [ ! -s "installed.cook.diff" ] && \
pankso@141 448 busybox diff installed.list installed.cook > installed.cook.diff
pankso@113 449 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@1 450
pankso@1 451 # Get source tarball and make sure we have source dir named:
paul@62 452 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
paul@62 453 # tarball if it exists.
pankso@1 454 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
pankso@1 455 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
pankso@10 456 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
pankso@1 457 else
pankso@1 458 get_source || exit 1
pankso@1 459 fi
pankso@1 460 fi
pankso@9 461 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
pankso@1 462 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
pankso@1 463 extract_source || exit 1
paul@62 464 # Some archives are not well done and don't extract to one dir (ex lzma).
pankso@57 465 files=$(ls | wc -l)
pankso@57 466 [ "$files" == 1 ] && mv * ../$PACKAGE-$VERSION
pankso@57 467 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
pankso@57 468 mv * ../$PACKAGE-$VERSION
pankso@1 469 cd .. && rm -rf tmp
pankso@1 470 fi
pankso@1 471
pankso@9 472 # Execute receipt rules.
pankso@44 473 if grep -q ^compile_rules $receipt; then
pankso@1 474 gettext -e "Executing: compile_rules\n"
pankso@55 475 [ -d "$src" ] && cd $src
pankso@97 476 compile_rules $@ || exit 1
pankso@10 477 # Stay compatible with _pkg
pankso@55 478 [ -d "$src/_pkg" ] && mv $src/_pkg $install
pankso@9 479 # QA: compile_rules success so valid.
pankso@9 480 mkdir -p $install
pankso@9 481 else
pankso@9 482 # QA: No compile_rules so no error, valid.
pankso@9 483 mkdir -p $install
pankso@1 484 fi
pankso@1 485 separator && echo ""
pankso@1 486 }
pankso@1 487
pankso@1 488 # Cook quality assurance.
pankso@1 489 cookit_quality() {
pankso@9 490 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
pankso@15 491 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
pankso@9 492 fi
pankso@9 493 # ERROR can be echoed any time in cookit()
pankso@33 494 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@17 495 debug_info | tee -a $LOGS/$pkg.log
pankso@33 496 rm -f $command && exit 1
pankso@1 497 fi
pankso@1 498 }
pankso@1 499
pankso@16 500 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
paul@62 501 # but it doesn't handle EXTRAVERSION.
pankso@1 502 packit() {
pankso@1 503 set_paths
pankso@55 504 echo "Pack: $PACKAGE $VERSION"
pankso@1 505 separator
pankso@44 506 if grep -q ^genpkg_rules $receipt; then
pankso@16 507 gettext -e "Executing: genpkg_rules\n"
pankso@16 508 cd $pkgdir
pankso@98 509 mkdir -p $fs && genpkg_rules || echo -e \
pankso@98 510 "\nERROR: genpkg_rules failed\n" >> $LOGS/$pkg.log
pankso@16 511 fi
pankso@98 512
pankso@98 513 # First QA check to stop now if genpkg_rules failed.
pankso@98 514 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@98 515 exit 1
pankso@98 516 fi
pankso@98 517
pankso@44 518 cd $taz
pankso@1 519 for file in receipt description.txt
pankso@1 520 do
pankso@1 521 [ ! -f "../$file" ] && continue
pankso@1 522 gettext "Copying"; echo -n " $file..."
pankso@1 523 cp -f ../$file $pack && chown 0.0 $pack/$file && status
pankso@1 524 done
pankso@119 525 copy_generic_files
pankso@16 526
paul@62 527 # Create files.list with redirecting find output.
pankso@16 528 gettext "Creating the list of files..." && cd $fs
pankso@16 529 find . -type f -print > ../files.list
pankso@16 530 find . -type l -print >> ../files.list
pankso@16 531 cd .. && sed -i s/'^.'/''/ files.list
pankso@16 532 status
pankso@43 533
pankso@119 534 # Strip and stuff files.
pankso@43 535 strip_package
pankso@43 536
pankso@43 537 # Md5sum of files.
pankso@16 538 gettext "Creating md5sum of files..."
pankso@16 539 while read file; do
pankso@16 540 [ -L "fs$file" ] && continue
pankso@16 541 [ -f "fs$file" ] || continue
pankso@16 542 case "$file" in
pankso@16 543 /lib/modules/*/modules.*|*.pyc) continue;;
pankso@16 544 esac
pankso@16 545 md5sum "fs$file" | sed 's/ fs/ /'
pankso@16 546 done < files.list > md5sum
pankso@16 547 status
pankso@16 548 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
pankso@16 549 description.txt 2> /dev/null | awk \
pankso@16 550 '{ sz=$1 } END { print sz }')
pankso@16 551
pankso@16 552 # Build cpio archives.
pankso@16 553 gettext "Compressing the fs... "
pankso@16 554 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
pankso@16 555 rm -rf fs
pankso@16 556 status
pankso@16 557 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
pankso@16 558 md5sum description.txt 2> /dev/null | awk \
pankso@16 559 '{ sz=$1 } END { print sz }')
pankso@16 560 gettext "Updating receipt sizes..."
pankso@16 561 sed -i s/^PACKED_SIZE.*$// receipt
pankso@16 562 sed -i s/^UNPACKED_SIZE.*$// receipt
pankso@16 563 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
pankso@16 564 status
pankso@16 565
pankso@16 566 # Set extra version.
pankso@16 567 if [ "$EXTRAVERSION" ]; then
pankso@16 568 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
pankso@16 569 sed -i s/^EXTRAVERSION.*$// receipt
pankso@16 570 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
pankso@16 571 status
pankso@16 572 fi
pankso@16 573
pankso@16 574 # Compress.
pankso@16 575 gettext "Creating full cpio archive... "
pankso@16 576 find . -print | cpio -o -H newc --quiet > \
pankso@16 577 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
pankso@16 578 status
pankso@16 579 gettext "Restoring original package tree... "
pankso@16 580 unlzma -c fs.cpio.lzma | cpio -idm --quiet
pankso@16 581 status
pankso@16 582 rm fs.cpio.lzma && cd ..
pankso@43 583
pankso@43 584 # QA and give info.
pankso@43 585 tazpkg=$(ls *.tazpkg)
pankso@43 586 packit_quality
pankso@43 587 separator && gettext "Package:"; echo -e " $tazpkg\n"
pankso@1 588 }
pankso@1 589
paul@62 590 # Verify package quality and consistency.
pankso@8 591 packit_quality() {
pankso@142 592 gettext "QA: Checking for broken link..."
pankso@143 593 link=$(find $taz -type l -follow)
pankso@143 594 [ "$link" ] && echo -e "\nERROR: broken link in filesystem"
pankso@143 595 status
pankso@142 596
pankso@142 597 # Exit if any error found in log file.
pankso@33 598 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@32 599 rm -f $command && exit 1
pankso@8 600 fi
pankso@142 601
pankso@44 602 gettext "QA: Checking for empty package..."
pankso@45 603 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
pankso@45 604 if [ "$files" -lt 0 ] && [ "$CATEGORY" != "meta" ]; then
pankso@44 605 echo -e "\nERROR: empty package"
pankso@32 606 rm -f $command && exit 1
pankso@8 607 else
pankso@134 608 # Ls sort by name so the first file is the one we want.
pankso@136 609 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
pankso@134 610 status
pankso@135 611 [ "$old" ] && echo -n "Removing old: $(basename $old)" && \
pankso@135 612 rm -f $old && status
pankso@134 613 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
pankso@11 614 sed -i /^${pkg}$/d $broken
pankso@8 615 fi
pankso@8 616 }
pankso@8 617
pankso@1 618 #
pankso@1 619 # Commands
pankso@1 620 #
pankso@1 621
pankso@1 622 case "$1" in
pankso@32 623 usage|help|-u|-h)
pankso@1 624 usage ;;
pankso@1 625 list-wok)
pankso@52 626 gettext -e "\nList of packages in:"; echo " $WOK"
pankso@1 627 separator
pankso@1 628 cd $WOK && ls -1
pankso@1 629 separator
pankso@1 630 echo -n "Packages: " && ls | wc -l
pankso@1 631 echo "" ;;
pankso@69 632 search)
pankso@69 633 # Just a simple search function, we dont need more actually.
pankso@69 634 query="$2"
pankso@69 635 gettext -e "\nSearch results for:"; echo " $query"
pankso@69 636 separator
pankso@69 637 cd $WOK && ls -1 | grep "$query"
pankso@69 638 separator && echo "" ;;
pankso@1 639 setup)
pankso@1 640 # Setup a build environment
pankso@1 641 check_root
pankso@11 642 echo "Cook: setting up the environment" | log
pankso@1 643 gettext -e "\nSetting up your environment\n"
pankso@1 644 separator && cd $SLITAZ
pankso@52 645 init_db_files
pankso@1 646 gettext -e "Checking for packages to install...\n"
pankso@29 647 for pkg in $SETUP_PKGS
pankso@1 648 do
pankso@52 649 [ ! -f "$INSTALLED/$pkg/receipt" ] && tazpkg get-install $pkg
pankso@1 650 done
pankso@1 651
pankso@1 652 # Handle --options
pankso@1 653 case "$2" in
pankso@49 654 --wok|-w)
pankso@52 655 [ ! -f "$INSTALLED/mercurial/receipt" ] && \
pankso@52 656 tazpkg get-install mercurial
paul@62 657 [ -d "$WOK" ] && echo -e "A wok already exists.\n" && exit 1
pankso@1 658 hg clone $HG_URL ;;
pankso@1 659 esac
pankso@1 660
pankso@1 661 # SliTaz group and permissions
pankso@1 662 if ! grep -q ^slitaz /etc/group; then
pankso@1 663 gettext -e "Adding group: slitaz\n"
pankso@1 664 addgroup slitaz
pankso@1 665 fi
pankso@1 666 gettext -e "Setting permissions for slitaz group...\n"
pankso@1 667 chown -R root.slitaz $SLITAZ
pankso@1 668 chmod -R g+w $SLITAZ
pankso@1 669 separator
pankso@1 670 gettext -e "All done, ready to cook packages :-)\n\n" ;;
pankso@9 671 test)
pankso@9 672 # Test a cook environment.
pankso@13 673 echo "Cook test: testing the cook environment" | log
pankso@9 674 [ ! -d "$WOK" ] && exit 1
pankso@9 675 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
pankso@9 676 cook cooktest ;;
pankso@1 677 new)
pankso@1 678 # Create the package folder and an empty receipt.
pankso@1 679 pkg="$2"
pankso@1 680 [ "$pkg" ] || usage
pankso@60 681 [ -d "${WOK}-hg" ] && WOK=${WOK}-hg
pankso@1 682 echo ""
pankso@1 683 if [ -d "$WOK/$pkg" ]; then
paul@62 684 echo -n "$pkg " && gettext "package already exists."
pankso@1 685 echo -e "\n" && exit 1
pankso@1 686 fi
pankso@1 687 gettext "Creating"; echo -n " $WOK/$pkg"
pankso@1 688 mkdir $WOK/$pkg && cd $WOK/$pkg && status
pankso@1 689 gettext "Preparing the package receipt..."
pankso@1 690 cp $DATA/receipt .
pankso@1 691 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
pankso@1 692 status && echo "" ;;
pankso@1 693 list)
pankso@1 694 # Cook a list of packages (better use the Cooker since it will order
pankso@1 695 # packages before executing cook).
pankso@1 696 check_root
pankso@1 697 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
pankso@1 698 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
pankso@1 699 echo -e " $2\n" && exit 1
pankso@13 700 echo "Cook list starting: $2" | log
pankso@1 701 for pkg in $(cat $2)
pankso@1 702 do
pankso@1 703 cook $pkg || broken
pankso@1 704 done ;;
pankso@1 705 clean-wok)
pankso@1 706 check_root
pankso@1 707 gettext -e "\nCleaning all packages files..."
pankso@1 708 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
pankso@1 709 status && echo "" ;;
pankso@1 710 clean-src)
pankso@1 711 check_root
paul@62 712 gettext -e "\nCleaning all packages sources..."
pankso@1 713 rm -rf $WOK/*/source
pankso@1 714 status && echo "" ;;
pankso@1 715 pkglist)
paul@62 716 # Create suitable packages list for TazPKG and only for built packages.
pankso@1 717 [ "$2" ] && PKGS="$2"
pankso@1 718 [ ! -d "$PKGS" ] && \
paul@62 719 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1
pankso@133 720 echo "cook:pkglist" > $command
paul@62 721 echo "Cook pkglist: Creating all packages lists" | log
pankso@1 722 gettext -e "\nCreating lists for:"; echo " $PKGS"
pankso@1 723 separator
pankso@133 724 cd $PKGS
pankso@1 725 rm -f packages.* files.list*
pankso@1 726 gettext -e "Creating: packages.list\n"
pankso@85 727 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
pankso@1 728 gettext -e "Creating: packages.md5\n"
pankso@1 729 md5sum *.tazpkg > $PKGS/packages.md5
pankso@1 730 gettext -e "Creating: packages.desc\n"
pankso@1 731 gettext -e "Creating: packages.equiv\n"
pankso@1 732 cd $WOK
pankso@1 733 for pkg in *
pankso@1 734 do
pankso@1 735 unset_receipt
pankso@1 736 . $pkg/receipt
pankso@1 737 # packages.desc let us search easily in DB
pankso@1 738 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 739 cat >> $PKGS/packages.desc << EOT
pankso@1 740 $PACKAGE | $VERSION$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
pankso@1 741 EOT
pankso@1 742 # Packages.equiv is used by tazpkg install to check depends.
pankso@1 743 for i in $PROVIDE; do
pankso@1 744 DEST=""
pankso@1 745 echo $i | fgrep -q : && DEST="${i#*:}:"
pankso@1 746 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
pankso@1 747 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
pankso@1 748 $PKGS/packages.equiv
pankso@1 749 else
pankso@1 750 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
pankso@1 751 fi
pankso@1 752 done
pankso@1 753 fi
pankso@1 754 done
pankso@1 755 # files.list.lzma
pankso@1 756 #lzma e files.list files.list.lzma
pankso@1 757 separator
pankso@1 758 nb=$(ls $PKGS/*.tazpkg | wc -l)
pankso@133 759 echo -e "Packages: $nb\n"
pankso@133 760 rm -f $command ;;
pankso@1 761 *)
pankso@1 762 # Just cook and generate a package.
pankso@1 763 check_root
pankso@1 764 time=$(date +%s)
pankso@1 765 pkg="$1"
pankso@1 766 [ -z "$pkg" ] && usage
pankso@44 767 receipt="$WOK/$pkg/receipt"
pankso@1 768 check_pkg_in_wok && echo ""
pankso@47 769
pankso@128 770 # Display and log info if cook process stopped.
pankso@128 771 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
pankso@128 772 tee -a $LOGS/$pkg.log' INT
pankso@128 773
pankso@47 774 # Skip blocked, 3 lines also for the Cooker.
pankso@51 775 if grep -q "^$pkg$" $blocked && [ "$2" != "--*" ]; then
pankso@47 776 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
pankso@47 777 fi
pankso@47 778
pankso@47 779 # Log and source receipt.
pankso@56 780 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
pankso@16 781 echo "cook:$pkg" > $command
pankso@1 782 unset inst
pankso@1 783 unset_receipt
pankso@44 784 . $receipt
pankso@1 785
pankso@1 786 # Handle --options
pankso@1 787 case "$2" in
pankso@1 788 --clean|-c)
pankso@49 789 gettext -e "Cleaning:"; echo -n " $pkg"
pankso@1 790 cd $WOK/$pkg && rm -rf install taz source
pankso@1 791 status && echo "" && exit 0 ;;
pankso@1 792 --install|-i)
pankso@1 793 inst='yes' ;;
pankso@49 794 --getsrc|-gs)
pankso@49 795 gettext "Getting source for:"; echo " $pkg"
pankso@45 796 separator && get_source
pankso@39 797 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
pankso@49 798 --block|-b)
pankso@49 799 gettext "Blocking:"; echo -n " $pkg"
pankso@49 800 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
pankso@49 801 status && echo "" && exit 0 ;;
pankso@49 802 --unblock|-ub)
pankso@49 803 gettext "Unblocking:"; echo -n " $pkg"
pankso@49 804 sed -i "/^${pkg}$/"d $blocked
pankso@49 805 status && echo "" && exit 0 ;;
pankso@1 806 esac
pankso@1 807
paul@62 808 # Check if wanted is built now so we have separate log files.
pankso@1 809 if [ "$WANTED" ] && [ ! -d "$WOK/$WANTED/install" ]; then
pankso@138 810 if ! grep -q "^$WANTED$" $broken; then
pankso@137 811 cook "$WANTED"
pankso@137 812 fi
pankso@1 813 fi
pankso@1 814
pankso@1 815 # Cook and pack or exit on error and log everything.
pankso@97 816 cookit $@ 2>&1 | tee $LOGS/$pkg.log
pankso@15 817 remove_deps | tee -a $LOGS/$pkg.log
pankso@1 818 cookit_quality
pankso@26 819 packit 2>&1 | tee -a $LOGS/$pkg.log
pankso@1 820 clean_log
pankso@33 821
pankso@33 822 # Exit if any error in packing.
pankso@33 823 if grep -q ^ERROR $LOGS/$pkg.log; then
pankso@33 824 debug_info | tee -a $LOGS/$pkg.log
pankso@33 825 rm -f $command && exit 1
pankso@33 826 fi
pankso@16 827
pankso@1 828 # Time and summary
pankso@1 829 time=$(($(date +%s) - $time))
pankso@1 830 summary | tee -a $LOGS/$pkg.log
pankso@50 831 echo ""
pankso@1 832
pankso@1 833 # Install package if requested
pankso@1 834 if [ "$inst" ]; then
pankso@1 835 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 836 cd $PKGS && tazpkg install \
pankso@1 837 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
pankso@1 838 else
paul@62 839 gettext -e "Unable to install package, build has failed.\n\n"
pankso@1 840 exit 1
pankso@1 841 fi
pankso@1 842 fi
pankso@9 843 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
pankso@17 844 # You want automation: use the Cooker Build Bot.
pankso@1 845 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
pankso@18 846 rm -f $command ;;
pankso@1 847 esac
pankso@1 848
pankso@1 849 exit 0